/*
 * Teaser - an ICQ like server for the client `firecat'.
 * Copyright (C) 1998 Matthew Parry <mettw@bowerbird.com.au>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <teaser.h>

PGconn *pg_conn;

void notify_contacts(char*, char*, PGconn*);

void
firecat_updstat(struct client_info slave_socket, struct input client_input){
  PGresult *result;
  char *pgexec;
  int pid;

  /* Open a connection to the database */
  pg_conn = PQsetdb("localhost", NULL, NULL, NULL, "teaserdb");
  /* check it opened OK */
  if(PQstatus(pg_conn) == CONNECTION_BAD){
	t_error(PQerrorMessage(pg_conn), TRUE);
  }


  /* check that the password is OK */
  pgexec = malloc((strlen("SELECT password FROM Auth WHERE tfa = '") +
		   strlen(client_input.tfa) + strlen("';")+1) *
		  sizeof(char));
  strcpy(pgexec, "SELECT password FROM Auth WHERE tfa = '");
  strcat(pgexec, client_input.tfa);
  strcat(pgexec, "';");

  t_error(pgexec, FALSE);
  result = db_exec(pg_conn, pgexec);

  if(result == NULL){
    tfp_error(slave_socket.socket, 402);
    t_error(PQerrorMessage(pg_conn), FALSE);
    free(pgexec);
    PQfinish(pg_conn);
    return;
  }

  if(PQresultStatus(result) == PGRES_TUPLES_OK && PQntuples(result) == 1){
    
    if(strcmp(client_input.password, PQgetvalue(result, 0, 0)) != 0){
      tfp_error(slave_socket.socket, 300);
      t_error(PQerrorMessage(pg_conn), FALSE);
      
      free(pgexec);
      PQfinish(pg_conn);
      return;
    }
  
  }else{
    tfp_error(slave_socket.socket, 201);
    t_error(PQerrorMessage(pg_conn), FALSE);
    
    free(pgexec);
    PQfinish(pg_conn);
    return;
  }
  
  
  free(pgexec);

  /* update the user status */
  pgexec = malloc((strlen("UPDATE Status SET status = '") +
		   strlen(client_input.status) +
		   strlen("' WHERE tfa = '") +
		   strlen(client_input.tfa) +
		   strlen("';")+1) * sizeof(char));
  strcpy(pgexec, "UPDATE Status SET status = '");
  strcat(pgexec, client_input.status);
  strcat(pgexec, "' WHERE tfa = '");
  strcat(pgexec, client_input.tfa);
  strcat(pgexec, "';");

  t_error(pgexec, FALSE);
  result = db_exec(pg_conn, pgexec);

  if(result == NULL){
    tfp_error(slave_socket.socket, 402);
    t_error(PQerrorMessage(pg_conn), FALSE);
    PQfinish(pg_conn);
    return;
  }

  free(pgexec);

  /* update the user status */
  pgexec = malloc((strlen("UPDATE Auth SET port = '") +
                   strlen(client_input.port) +
                   strlen("' , ipaddr = '") +
                   strlen(inet_ntoa(slave_socket.client_name.sin_addr)) +
		   strlen("' WHERE tfa = '") +
		   strlen(client_input.tfa) +
		   strlen("';")+1) * sizeof(char));
  strcpy(pgexec, "UPDATE Auth SET port = '");
  strcat(pgexec, client_input.port);
  strcat(pgexec, "' , ipaddr = '");
  strcat(pgexec, inet_ntoa(slave_socket.client_name.sin_addr));
  strcat(pgexec, "' WHERE tfa = '");
  strcat(pgexec, client_input.tfa);
  strcat(pgexec, "';");

  t_error(pgexec, FALSE);
  result = db_exec(pg_conn, pgexec);

  if(result == NULL){
    tfp_error(slave_socket.socket, 402);
    t_error(PQerrorMessage(pg_conn), FALSE);
    PQfinish(pg_conn);
    return;
  }

  
  free(pgexec);
  write(slave_socket.socket, "OK\n", strlen("OK\n"));

  /* notify the contacts of the user's change in status */
  notify_contacts(client_input.tfa, client_input.status, pg_conn);

  PQfinish(pg_conn);
}
